/*
 Katseprogramm infiksavaldiste ttlemiseks
 Autor: Dan Bogdanov
 13.07.2000

 Programmijupp, mis nitab kolme erinevat vimalust juuresoleva
 infiksavaldiste klassi kasutamiseks.
 */

#include <stdio.h>
#include <string.h>
#include <avaldis.h>

#define WIN32_LEAN_AND_MEAN
#include <windows.h>

#ifndef true
#define true 1
#define false 0
#endif

void trykijuhendid()
{
  printf("\n\nInfiksavaldiste kalkulaator\n");
  printf("Autor: Dan Bogdanov\n");
  printf("\nKalkulaator ttab kolmel moel:\n");
  printf("1) Ksurealt (kujul './testprog -k (1+2)-(3+4)')\n");
  printf("2) Failist (kujul './testprog -f skriptifail')\n");
  printf("3) Klaviatuurilt (ilma argumentideta kivitades)\n");
  printf("\nKalkulaator loeb sisendist rea ja leides sealt sna 'valju' vi 'abi'\n");
  printf("vastavalt vljub programmist vi kuvab siinoleva teksti.\n");
  printf("Kui realt leitakse vrdusmrk, eeldatakse, et rida on omistamine. Lubatud\n");
  printf("on igasuguse kehtiva avaldise omistamine muutujale. Muutujaile kehtib\n");
  printf("ldine phimte, et enne kasutamist tuleb neile anda vrtus.\n");
  printf("Kiki teisi sisestatud ridu koheldakse avaldistena ka siis, kui nad\n");
  printf("koosnevad vaid hest arvust/muutujast.\n");
  printf("\nNB! Komadena aktsepteerib programm nii punkti kui koma (. ja ,).\n");
  printf("    Thikud sisendis on lubatud.\n\n");
}

int loefailist(char* failinimi)
{
  infiksavaldis* av=new infiksavaldis();
  char* sisend=new char[80];
  char* avaldis=new char[80];
  char muutuja;
  int valju=false;

  // Avame faili
  FILE* sisendfail=fopen(failinimi, "r");
  if(sisendfail==NULL) {
  printf("Viga: Ei suuda avada faili!\n");
  goto faililopp;
  }

  // Loen kogu faili
  do {
    fgets(sisend, 80, sisendfail);
    if(feof(sisendfail)!=0) {
      valju=true;
      goto faililopp;
    }
    if(sisend!=NULL) {
      printf(":%s", sisend);
      if(strchr(sisend, '=')!=NULL) {
        sscanf(sisend, " %c = %s ", &muutuja, avaldis);
        if(av->omista(muutuja, avaldis)==true)
          printf("Muutuja %c vrtus=%f\n", muutuja, av->tulemus);
      }
      else {
        if(av->arvuta(sisend)==true)
          printf("Avaldise vrtus=%f\n", av->tulemus);
      }
    }
  } while(valju==false);
  
  fclose(sisendfail);
  faililopp:
  delete avaldis;
  delete sisend;
  delete av;
  return (int)av->tulemus;
}

void loesisendist()
{
  infiksavaldis* av=new infiksavaldis();
  char* sisend=new char[80];
  char* avaldis=new char[80];
  char muutuja;
  int valju=false;

  // Juhised...
  printf("Vljumiseks sisestage 'valju', juhiste saamiseks 'abi'\n");
  // Tskkel kuni 'valju'-miseni
  do {
    printf(":");
    do {
    fgets(sisend, 80, stdin);
    } while(sisend==NULL);
    if(strstr(sisend,"valju")!=0)
      valju=true;
    else if(strstr(sisend,"abi")!=0)
      trykijuhendid();
    else if(strchr(sisend, '=')!=NULL) {
      sscanf(sisend, " %c = %s ", &muutuja, avaldis);
      if(av->omista(muutuja, avaldis)==true)
        printf("Muutuja %c vrtus=%f\n", muutuja, av->tulemus);
    }
    else
      if(av->arvuta(sisend)==true)
        printf("Avaldise vrtus=%f\n", av->tulemus);
  } while(valju==false);

  delete avaldis;
  delete sisend;
  delete av;
}

int loekasurealt(char* sisend)
{
  infiksavaldis* av=new infiksavaldis();
  char* avaldis=new char[80];
  if(sisend==NULL) {
    printf("Viga: Ksureal puudub avaldis!\n");
    goto realopp;
  }
  printf(":%s \n", sisend);
  char muutuja;
  if(strchr(sisend, '=')!=NULL) {
   sscanf(sisend, " %c = %s ", &muutuja, avaldis);
    if(av->omista(muutuja, avaldis)==true)
      printf("Muutuja %c vrtus=%f\n", muutuja, av->tulemus);
  }
  else {
    if(av->arvuta(sisend)==true)
      printf("Avaldise vrtus=%f\n", av->tulemus);
  }
  realopp:
  delete avaldis;
  delete av;
  return (int)av->tulemus;
}

int main(int argc, char *argv[])
{
  // Tutvustame ennast
  printf("Infiksavaldiste kalkulaator\n");
  printf("Autor: Dan Bogdanov\n");

  // Uurime, mida me peame tegema
  // Kui ksureal on argument -f, siis peab jrgmine argument olema
  // failinimi, millest kske lugeda
  // Kui on ainult ks argument, eelda, et see on avaldis
  // Kui argumente pole, suuna kasutaja interpreteeriva konsooli peale


  if(argv[1]!=NULL) {
    if (strcmp(argv[1], "-f") == 0)
      return loefailist(argv[2]);
    if (strcmp(argv[1], "-k") == 0)
      return loekasurealt(argv[2]);
  }
  loesisendist();
  return 1;
}

int WINAPI WinMain (HINSTANCE hApp, HINSTANCE prev, LPSTR cmd, int show) {
  return main (0, NULL);
}


