/*
 Leksiline analsaator.
 Autor: Dan Bogdanov
 11.07.2000

 Funktsiooniga alusta() antakse analsaatorile string, millest
 jrjestikused vljakutsed funktsioonile loelekseem()-funktsioonile
 lahutavad kik tuntavad lekseemid.

 Vimalikud tiendused:
 Stringi asemel lasta andmeid lugeda mnest voost (sisendvoost/failist/...).
 */

#include <stdio.h>
#include <leksator.h>

//--Konstruktor---------------------------------------------------------------

leksator::leksator()
{
  string=NULL;
}

//--Destruktor----------------------------------------------------------------

leksator::~leksator()
{
  string=NULL;
}

//--Edastab parseldatava stringi----------------------------------------------

void leksator::alusta(char* uus_string)
{
  string=uus_string;
  koht=0;
}

//--Funktsioon, mis loeb stringist jrgmise lekseemi--------------------------

lekseem* leksator::loelekseem()
{
  char mark=0;
  int koma=0;
  int komakohti=0;
  lekseem *l=new lekseem;
  l->tyyp=0;
  // Thikud jtame vahele
  edasi: mark=string[koht++];
  if(mark==' ') goto edasi;
  // Kui tegemist on arvuga, siis loe ta koos komade ja kigega sisse ja
  // kirjutame ta vastavasse lekseemi
  if(mark>='0' && mark<='9' || mark=='.' || mark ==',')
  {
    l->tyyp=L_ARV;
    l->sisu=NULL;
    l->arv=0;
    while(mark>='0' && mark<='9' || mark=='.' || mark ==',')
    {
      if(mark=='.' || mark==',')
      {
        // Ainult ks koma on arvu kohta kll
        if(koma==true)
        {
          l->tyyp=L_VIGA;
          l->sisu="Lubamatu koma!";
        }
        koma=true;
        mark=string[koht++];
      }
      else
      {
        // Kui aga pole veel olnud htegi, siis las olla
        l->arv=10.0*l->arv+(float)(mark-'0');
        mark=string[koht++];
        if(koma==true)
          komakohti++;
      }
    }
    koht--;
    // Nii mitu kohta prast koma kui oli, tuleb ka arvust maha saada
    if(komakohti>0)
      l->arv=l->arv / (float)(komakohti*10);
    return l;
  }
  // Suurthtedega muutujad teeme vikethtedeks
  if(mark>='A' && mark<'Z')
    mark+=32;
  // Loome vastava lekseemi
  if(mark>='a' && mark<'z')
  {
    l->tyyp=L_MUUT;
    l->sisu=(char*)mark;
    l->arv=0;
    return l;
  }
  // Loome tehtemrgile vastava lekseemi
  else if(mark=='+' || mark=='-' || mark=='*' || mark=='/' || mark=='(' || mark==')')
  {
    l->tyyp=L_MARK;
    l->sisu=(char*)mark;
    return l;
  }
  // Vi kui stringi lpp on ligidal, siis paneme veel viimase lekseemi
  else if(mark==0xA || mark==0) {
    l->tyyp=L_LOPP;
    return l;
  }
  // Kui on tegemist mingi anomaaliaga, siis anname veateate
  else
  {
    l->tyyp=L_VIGA;
    l->sisu="Lubamatu smbol real!";
  }
  return l;
}

//--Lpp----------------------------------------------------------------------

