/*
  Rooma numbrite teisendamine araabia numbriteks
  Autor: Dan Bogdanov

  Algoritm: lpliku olekute hulgaga automaat. Prit A. Isotamme
  Algoritmide & andmestruktuuride loengust 10.09.2002

  Lihtsustatud variant: konstruktsioonid stiilis IM, IC, XM on keelatud.

  24.09.2002
*/

#include <araabia.h>

#include <string.h>
#include <malloc.h>

//--Konstruktor---------------------------------------------------------------

araabia::araabia (char* a_rooma)
{
  rooma = strdup (a_rooma);
  pikkus = strlen (rooma);
  olek = 's';
  arv = 0;
  ic = xc = cc = 0;
}

//--Destruktor----------------------------------------------------------------

araabia::~araabia() {
  if (rooma)
    free (rooma);
}

//--Funktsioon, mis tagastab rooma numbri araabia vrtuse--------------------

int araabia::vaartus ()
{
  if (pikkus == 0)
    return 0;

  for (int i = 0; i < pikkus; i++) {
    switch (olek) {
      case 's': if (!start (rooma[i])) return -1; break;
      case 'i': if (!uks (rooma[i])) return -1; break;
      case 'v': if (!viis (rooma[i])) return -1; break;
      case 'x': if (!kumme (rooma[i])) return -1; break;
      case 'l': if (!viiskummend (rooma[i])) return -1; break;
      case 'c': if (!sada (rooma[i])) return -1; break;
      case 'd': if (!viissada (rooma[i])) return -1; break;
      case 'm': if (!tuhat (rooma[i])) return -1; break;
    }
  }

  return arv;
}

//--Olek 'start'--------------------------------------------------------------

int araabia::start (char key)
{
  int flag = 1;
  switch (key) {
    case 'O':
    case 'o':
      arv = 0; break;
    case 'I':
    case 'i':
      olek = 'i'; ic = 1; arv = 1; break;
    case 'V':
    case 'v':
      olek = 'v'; arv = 5; break;
    case 'X':
    case 'x':
      olek = 'x'; xc = 1; arv = 10; break;
    case 'L':
    case 'l':
      olek = 'l'; arv = 50; break;
    case 'C':
    case 'c':
      olek = 'c'; cc = 1; arv = 100; break;
    case 'D':
    case 'd':
      olek = 'd'; arv = 500; break;
    case 'M':
    case 'm':
      olek = 'm'; arv = 1000; break;
    default:
      flag = 0;
  }

  return flag;
}

//--Olek 'ks'----------------------------------------------------------------

int araabia::uks (char key)
{
  int flag = 1;
  switch (key) {
    case 'I':
    case 'i':
      ic ++;
      if (ic > 3)
        flag = 0;
      else
        arv++;
      break;
    case 'V':
    case 'v':
      if (ic == 1) {
        olek = 'v';
        arv += 3;
      } else {
        flag = 0;
      }
      break;
    case 'X':
    case 'x':
      if (ic == 1) {
        olek = 'x';
        arv += 8;
      } else {
        flag = 0;
      }
      break;
    default:
      flag = 0;
  }

  return flag;
}

//--Olek 'viis'---------------------------------------------------------------

int araabia::viis (char key)
{
  int flag = 1;
  switch (key) {
    case 'I':
    case 'i':
      if (ic > 0) {
        flag = 0;
      } else {
        olek = 'i';
        ic = 1;
        arv++;
      }
      break;
    default:
      flag = 0;
  }

  return flag;
}

//--Olek 'kmme'--------------------------------------------------------------

int araabia::kumme (char key)
{
  int flag = 1;
  switch (key) {
    case 'I':
    case 'i':
      if (ic > 0) {
        flag = 0;
      } else {
        olek = 'i';
        ic = 1;
        arv++;
      }
      break;
    case 'V':
    case 'v':
      olek = 'v';
      arv += 5; break;
    case 'X':
    case 'x':
      xc ++;
      if (xc > 3)
        flag = 0;
      else
        arv += 10;
      break;
    case 'L':
    case 'l':
      if (xc == 1) {
        olek = 'l';
        arv += 30;
      } else {
        flag = 0;
      }
      break;
    case 'C':
    case 'c':
      if (xc == 1) {
        olek = 'c';
        arv += 80;
      } else {
        flag = 0;
      }
      break;
    default:
      flag = 0;
  }

  return flag;
}

//--Olek 'viiskmmend'--------------------------------------------------------

int araabia::viiskummend (char key)
{
  int flag = 1;
  switch (key) {
    case 'I':
    case 'i':
      olek = 'i'; ic = 1; arv++; break;
    case 'V':
    case 'v':
      olek = 'v'; arv += 5; break;
    case 'X':
    case 'x':
      if (xc > 0) {
        flag = 0;
      } else {
        olek = 'x';
        xc = 1;
        arv += 10;
      }
      break;
    default:
      flag = 0;
  }

  return flag;
}

//--Olek 'sada'---------------------------------------------------------------

int araabia::sada (char key)
{
  int flag = 1;
  switch (key) {
    case 'I':
    case 'i':
      olek = 'i'; ic = 1; arv++; break;
    case 'V':
    case 'v':
      olek = 'v'; arv += 5; break;
    case 'X':
    case 'x':
      if (xc > 0) {
        flag = 0;
      } else {
        olek = 'x';
        xc = 1;
        arv += 10;
      }
      break;
    case 'L':
    case 'l':
      olek = 'l'; arv += 50; break;
    case 'C':
    case 'c':
      cc++;
      if (cc > 3) {
        flag = 0;
      } else {
        arv += 100;
      }
      break;
    case 'D':
    case 'd':
      if (cc == 1) {
        olek = 'd';
        arv += 300;
      } else {
        flag = 0;
      }
      break;
    case 'M':
    case 'm':
      if (cc == 1) {
        olek = 'm';
        arv += 800;
      } else {
        flag = 0;
      }
      break;
    default:
      flag = 0;
  }

  return flag;
}

//--Olek 'viissada'-----------------------------------------------------------

int araabia::viissada (char key)
{
  int flag = 1;
  switch (key) {
    case 'I':
    case 'i':
      olek = 'i'; ic = 1; arv++; break;
    case 'V':
    case 'v':
      olek = 'v'; arv += 5; break;
    case 'X':
    case 'x':
      olek = 'x'; xc = 1; arv += 10; break;
    case 'L':
    case 'l':
      olek = 'l'; arv += 50; break;
    case 'C':
    case 'c':
      if (cc > 0) {
        flag = 0;
      } else {
        olek = 'c';
        cc = 1;
        arv += 100;
      }
      break;
    default:
      flag = 0;
  }

  return flag;
}

//--Olek 'tuhat'--------------------------------------------------------------

int araabia::tuhat (char key)
{
  int flag = 1;
  switch (key) {
    case 'I':
    case 'i':
      olek = 'i'; ic = 1; arv++; break;
    case 'V':
    case 'v':
      olek = 'v'; arv += 5; break;
    case 'X':
    case 'x':
      olek = 'x'; xc = 1; arv += 10; break;
    case 'L':
    case 'l':
      olek = 'l'; arv += 50; break;
    case 'C':
    case 'c':
      if (cc > 1) {
        flag = 0;
      } else {
        cc = 1;
        olek = 'c';
        arv += 100;
      }
      break;
    case 'D':
    case 'd':
      olek = 'd'; arv += 500; break;
      break;
    case 'M':
    case 'm':
      arv += 1000;
      break;
    default:
      flag = 0;
  }

  return flag;
}

//--Lpp----------------------------------------------------------------------

